'
'  primes      Calculate prime numbers
'
'  This routine calculates and displays the first n prime numbers, where
'  n is set by the constant LIMIT below.
'
'  Note:  This program creates an array LIMIT elements long.  Make sure
'  you move your variables to a safe area so you have plenty of memory
'  available for the array.  (See the /v option in the manual.)
'


include  "regs11.lib"

const  true = -1
const  false = 0
const  LIMIT = 400

declare  primes(LIMIT)
declare  nprimes
declare  n
declare  base
declare  flag


test:
flag = true
for n = 0 to nprimes - 1
	if pick(0) mod primes(n) = 0
		flag = false
		drop 1
		return  flag
	endif
next
drop 1
return flag


main:
pokeb  baud, $30
pokeb  sccr2, $0c
print
print "primes"
print
print "The first "; LIMIT; "prime numbers are:"
print

nprimes = 0
base = 2
do
	if usr(test, base) = true
		primes(nprimes) = base
		nprimes = nprimes + 1
		print base; " ";
	endif
	base = base + 1
loop while nprimes < LIMIT
print

end

